package envoy;

import java.time.Instant;

import javax.ws.rs.client.Client;
import javax.ws.rs.client.ClientBuilder;
import javax.ws.rs.client.Entity;
import javax.ws.rs.client.WebTarget;
import javax.ws.rs.core.Response;
import javax.xml.bind.JAXBException;
import javax.xml.datatype.DatatypeConfigurationException;
import javax.xml.datatype.DatatypeFactory;

import envoy.schema.Message;
import envoy.schema.ObjectFactory;

/**
 * Project: <strong>envoy-client</strong><br>
 * File: <strong>EnvoyClient.java</strong><br>
 * Created: <strong>28 Sep 2019</strong><br>
 * Author: <strong>Kai S. K. Engelbart</strong>
 */
public class EnvoyClient {

	public static void main(String[] args) throws DatatypeConfigurationException, JAXBException {
		ObjectFactory factory = new ObjectFactory();

		Message.MetaData metaData = factory.createMessageMetaData();
		metaData.setSender("Kai");
		metaData.setRecipient("Maxi");
		metaData.setState(false);
		metaData.setDate(DatatypeFactory.newInstance().newXMLGregorianCalendar(Instant.now().toString()));

		Message.Content content = factory.createMessageContent();
		content.setType("text");
		content.setText("Hello, World");

		Message message = factory.createMessage();
		message.setMetaData(metaData);
		message.getContent().add(content);

		Client		client		= ClientBuilder.newClient();
		WebTarget	target		= client.target("http://localhost:8080/envoy-server/rest/message/send");
		Response	response	= target.request().post(Entity.entity(message, "application/xml"));
		response.close();
	}
}
